Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4901)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1)
@@ -1,254 +1,112 @@
-!> @file time_integration.f90
+ SUBROUTINE time_integration
+
 !------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
-!
+! Actual revisions:
+! -----------------
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! replaced use_syn_turb_gen by syn_turb_gen
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! Remove leftover write statement from debugging
-!
-! 4802 2020-11-30 14:16:31Z suehring
-! Bugfix in time-control of indoor model at the very first time step
-!
-! 4732 2020-10-07 14:46:34Z schwenkel
-! Add use statements for OPENACC
-!
-! 4731 2020-10-07 13:25:11Z schwenkel
-! Move exchange_horiz from time_integration to modules
-!
-! 4671 2020-09-09 20:27:58Z pavelkrc
-! Implementation of downward facing USM and LSM surfaces
-!
-! 4669 2020-09-09 13:43:47Z pavelkrc
-! - Fix missing call of radiation after spinup
-! - Fix calculation of force_radiation_call
-! - Fix calculation of radiation times
-!
-! 4668 2020-09-09 13:00:16Z pavelkrc
-! Improve debug messages during timestepping
-!
-! 4581 2020-06-29 08:49:58Z suehring
-! Omit explicit pressure forcing via geostrophic wind components in case of
-! mesoscale nesting.
-!
-! 4578 2020-06-25 15:43:32Z gronemeier
-! bugfix: removed unused variables
-!
-! 4573 2020-06-24 13:08:47Z oliver.maas
-! calculate pt(0) incrementally by using dt_3d instead of calculating it absolutely
-! by using time_since_reference_point, because time_since_reference_point is set
-! to zero for initializing_actions = 'cyclic_fill'
-!
-! 4565 2020-06-15 08:30:38Z oliver.maas
-! added new surface temperature forcing method for bc_pt_b = 'dirichlet':
-! surface temperature pt(0) can be linearly increased by pt_surface_heating_rate (in K/h)
-!
-! 4564 2020-06-12 14:03:36Z raasch
-! Vertical nesting method of Huq et al. (2019) removed
-!
-! 4521 2020-05-06 11:39:49Z schwenkel
-! Rename variable
-!
-! 4511 2020-04-30 12:20:40Z raasch
-! chemistry decycling replaced by explicit setting of lateral boundary conditions
-!
-! 4508 2020-04-24 13:32:20Z raasch
-! salsa decycling replaced by explicit setting of lateral boundary conditions
-!
-! 4502 2020-04-17 16:14:16Z schwenkel
-! Implementation of ice microphysics
-!
-! 4472 2020-03-24 12:21:00Z Giersch
-! OPENACC COPYIN directive for ddx and ddy added
-!
-! 4466 2020-03-20 16:14:41Z suehring
-! Add advection fluxes to ACC copyin
-!
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4420 2020-02-24 14:13:56Z maronga
-! Added output control for wind turbine model
-!
-! 4403 2020-02-12 13:08:46Z banzhafs
-! Allowing both existing and on-demand emission read modes
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Bugfix, hour_call_emis uninitialized at first call of time_integration
-!
-! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4281 2019-10-29 15:15:39Z schwenkel
-! Moved boundary conditions to module interface
-!
-! 4276 2019-10-28 16:03:29Z schwenkel
-! Further modularization of lpm code components
-!
-! 4275 2019-10-28 15:34:55Z schwenkel
-! Move call oft lpm to the end of intermediate timestep loop
-!
-! 4268 2019-10-17 11:29:38Z schwenkel
-! Removing module specific boundary conditions an put them into their modules
-!
-! 4227 2019-09-10 18:04:34Z gronemeier
-! implement new palm_date_time_mod
-!
-! 4226 2019-09-10 17:03:24Z suehring
-! Changes in interface for the offline nesting
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4170 2019-08-19 17:12:31Z gronemeier
-! copy diss, diss_p, tdiss_m to GPU
-!
-! 4144 2019-08-06 09:11:47Z raasch
-! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
-!
-! 4126 2019-07-30 11:09:11Z gronemeier
-! renamed routine to calculate uv exposure
-!
-! 4111 2019-07-22 18:16:57Z suehring
-! advc_flags_1 / advc_flags_2 renamed to advc_flags_m / advc_flags_s
-!
-! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to
-! avoid runtime error (Loop variable has been modified) in time_integration
-!
-! 4064 2019-07-01 05:33:33Z gronemeier
-! Moved call to radiation module out of intermediate time loop
-!
-! 4048 2019-06-21 21:00:21Z knoop
-! Moved production_e_init call into turbulence_closure_mod
-!
-! 4047 2019-06-21 18:58:09Z knoop
-! Added remainings of swap_timelevel upon its dissolution
-!
-! 4043 2019-06-18 16:59:00Z schwenkel
-! Further LPM modularization
-!
-! 4039 2019-06-18 10:32:41Z suehring
-! Rename subroutines in module for diagnostic quantities
-!
-! 4029 2019-06-14 14:04:35Z raasch
-! exchange of ghost points and boundary conditions separated for chemical species and SALSA module,
-! bugfix: decycling of chemistry species after nesting data transfer
-!
-! 4022 2019-06-12 11:52:39Z suehring
-! Call synthetic turbulence generator at last RK3 substep right after boundary
-! conditions are updated in offline nesting in order to assure that
-! perturbations are always imposed
-!
-! 4017 2019-06-06 12:16:46Z schwenkel
-! Mass (volume) flux correction included to ensure global mass conservation for child domains.
-!
-! 3994 2019-05-22 18:08:09Z suehring
-! output of turbulence intensity added
-!
-! 3988 2019-05-22 11:32:37Z kanani
-! Implement steerable output interval for virtual measurements
-!
-! 3968 2019-05-13 11:04:01Z suehring
-! replace nspec_out with n_matched_vars
-!
-! 3929 2019-04-24 12:52:08Z banzhafs
-! Reverse changes back from revision 3878: use chem_boundary_conds instead of
-! chem_boundary_conds_decycle
-!
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction
-! of additional debug messages
-!
-! 3879 2019-04-08 20:25:23Z knoop
-! Moved wtm_forces to module_interface_actions
-!
-! 3872 2019-04-08 15:03:06Z knoop
-! Modifications made for salsa:
-! - Call salsa_emission_update at each time step but do the checks within
-!   salsa_emission_update (i.e. skip_time_do_salsa >= time_since_reference_point
-!   and next_aero_emission_update <= time_since_reference_point ).
-! - Renamed nbins --> nbins_aerosol, ncc_tot --> ncomponents_mass and
-!   ngast --> ngases_salsa and loop indices b, c and sg to ib, ic and ig
-! - Apply nesting for salsa variables
-! - Removed cpu_log calls speciffic for salsa.
-!
-! 3833 2019-03-28 15:04:04Z forkel
-! added USE chem_gasphase_mod, replaced nspec by nspec since fixed compounds are not integrated
-!
-! 3820 2019-03-27 11:53:41Z forkel
-! renamed do_emiss to emissions_anthropogenic (ecc)
-!
-!
-! 3774 2019-03-04 10:52:49Z moh.hefny
-! rephrase if statement to avoid unallocated array in case of
-! nesting_offline is false (crashing during debug mode)
-!
-! 3761 2019-02-25 15:31:42Z raasch $
-! module section re-formatted and openacc required variables moved to separate section,
-! re-formatting to 100 char line width
-!
-! 3745 2019-02-15 18:57:56Z suehring
-! Call indoor model after first timestep
-!
-! 3744 2019-02-15 18:38:58Z suehring
-! - Moved call of bio_calculate_thermal_index_maps from biometeorology module to
-! time_integration to make sure averaged input is updated before calculating.
-!
-! 3739 2019-02-13 08:05:17Z dom_dwd_user
-! Removed everything related to "time_bio_results" as this is never used.
-!
-! 3724 2019-02-06 16:28:23Z kanani
-! Correct double-used log_point_s unit
-!
-! 3719 2019-02-06 13:10:18Z kanani
-! - removed wind_turbine cpu measurement, since same time is measured inside
-!   wtm_forces subroutine as special measures
-! - moved the numerous vnest cpulog to special measures
-! - extended radiation cpulog over entire radiation part,
-!   moved radiation_interactions cpulog to special measures
-! - moved some cpu_log calls to this routine for better overview
-!
-! 3705 2019-01-29 19:56:39Z suehring
-! Data output for virtual measurements added
-!
-! 3704 2019-01-29 19:51:41Z suehring
-! Rename subroutines for surface-data output
-!
-! 3647 2019-01-02 14:10:44Z kanani
-! Bugfix: add time_since_reference_point to IF clause for data_output calls
-! (otherwise skip_time_* values don't come into affect with dt_do* = 0.0).
-! Clean up indoor_model and biometeorology model call.
-!
+! $Log: time_integration.f90,v $
+! Revision 1.8  2006/08/22 14:16:05  raasch
+! Disturbances are imposed only for the last Runge-Kutta-substep
+!
+! Revision 1.7  2006/08/04 15:04:39  raasch
+! Output of particle timeseries
+!
+! Revision 1.6  2006/02/23 12:58:38  raasch
+! Data output (1d, 2d, 3d, sp) can be skipped for a given time interval from
+! simulation start, additional argument nzb_.._inner added to call of
+! disturb_field, nt_anz renamed current_timestep_number, pl.. renamed do..,
+! ..anz renamed ..n, dt_average renamed dt_averaging_interval_pr,
+! time_average_.. renamed time_do.._av, routines plot_.. renamed data_output_..,
+! additional call of user_actions (after_integration)
+!
+! Revision 1.5  2005/06/26 20:10:20  raasch
+! +call of interaction_droplets_ptq (+module of the same name)
+!
+! Revision 1.4  2005/04/23 09:39:01  raasch
+! Revised calculation of output time counters regarding a possible decrease of
+! the output time interval in case of restart runs
+!
+! Revision 1.3  2005/03/26 21:10:26  raasch
+! Pres is called by default only at the last Runge-Kutta-substep.
+! Determination of the timestep moved from end to the beginning of the
+! time loop in order to assure consistent output in run_control (first line
+! in restart runs must be equal to the last line in the corresponding
+! previous run). Exchange of ghost points for km and kh removed.
+! Changes regarding non-cyclic boundary conditions:
+! arguments are added to call of routines disturb_field, exchange_horiz,
+! and boundary_conds, which is now called for a second time after pres in
+! order to set the velocity boundary conditions at the outflow. Velocity
+! perturbations are imposed near the inflow throughout the whole run.
+!
+! Revision 1.2  2004/04/30 13:03:40  raasch
+! decalpha-specific warning removed, routine name changed to time_integration,
+! particle advection is carried out only once during the intermediate steps,
+! impulse_advec renamed momentum_advec
+!
+! Revision 1.1  2004/04/30 12:58:21  raasch
+! Initial revision
+!
+! Revision 1.44  2004/01/28 15:17:26  raasch
+! Additional intermediate timesteps for the Runge-Kutta schemes, setting
+! of the steering factors for prognostic equations within the new
+! routine timestep_scheme_steering at the beginning of each step (former
+! part of routine timestep called at the end of each step), routine
+! run_control is not called for the Runge-Kutta schemes automatically in case
+! of timestep changes.
+!
+! Revision 1.43  2003/03/16 09:40:12  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.42  2003/03/12 16:33:23  raasch
+! New routine prognostic_equations_vec is used on NEC machines
+!
+! Revision 1.41  2003/03/04 11:31:39  raasch
+! Module DVRP added in case that dvrp graphics package is switched on
+!
+! Revision 1.40  2002/12/19 15:45:13  raasch
+! Routine check_cpu_time renamed to check_for_restart
+!
+! Revision 1.39  2002/06/11 13:11:44  raasch
+! +USE user_actions_mod, prognostic_equations_mod,
+! temperature offset at cyclic boundaries in case of sloping surface moved
+! from prognostic_equations to this subroutine. Particle advection moved from
+! prognostic_equations to this routine. A fast version of prognostic_equations
+! is called in case that the Piascek-Williams advection scheme is used.
+!
+! Revision 1.38  2002/05/02 18:52:19  raasch
+! Application of time filter and exchange of ghost points moved from
+! prognostic_equations to this routine.
+! Error in calculating output time intervals for various quantities removed.
+!
+! Revision 1.37  2001/08/21  09:51:26  09:51:26  raasch (Siegfried Raasch)
+! Time measurements for user_actions moved to that subroutine
+! 
+! Revision 1.36  2001/03/30 07:34:24  raasch
+! Timelevel t+dt eliminated, Asselin filter now included in
+! prognostic_equations, arguments removed from pres,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.35  2001/01/25 07:06:43  raasch
+! Time measurements with dvrp software included
+!
+! Revision 1.34  2001/01/05 15:12:50  raasch
+! Calculation and plot of spectra
+!
+! Revision 1.33  2000/04/27 06:40:49  raasch
+! Old revision remarks deleted, output of isosurfaces and particles now
+! combined into new routine data_output_dvrp (includes former routines
+! plot_particles and plot_isosurface)
+!
+! Revision 1.32  2000/04/13 13:39:30  schroeter
+! computation of prognostic equations moved to the new routine
+! prognostic_equation, new routines calc_liquid_water_content and
+! compute_vpt
+!
+! Revision 1.31  2000/01/25  16:25:24  16:25:24  letzel (Marcus Letzel)
+! All comments translated into English
+! 
 ! Revision 1.1  1997/08/11 06:19:04  raasch
 ! Initial revision
